package cz.kebrt.unitcheck.junit;

/**
 * Various JUnit utility methods.
 *
 * @author michal
 */
public final class JUnitUtil {

    private static final String[] JUNIT_PREFIXES = {
        "org/junit",
        "cz/kebrt/unitcheck/junit",
        "junit/framework",
        "junit/runner"
    };

    private JUnitUtil() { }

    /**
     * Returns true when the location of code belongs to JUnit or
     * UnitCheck internal code.
     *
     * @param location location of the code
     * @return true when the line of code belongs to JUnit or
     *         UnitCheck internal code.
     */
    public static boolean isJUnitCode(String location) {
        if (location == null) {
            return false;
        }
        for (String prefix : JUNIT_PREFIXES) {
            if (location.contains(prefix)) {
                return true;
            }
        }
        return false;
    }

}
