package cz.kebrt.unitcheck.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import gov.nasa.jpf.jvm.Verify;

import org.junit.Test;

public class BankAccountTest {

	private static class Banker implements Runnable {
		private Account account;
		private int amount;
		private int count;

		public Banker(Account account, int amount, int count) {
			this.account = account;
			this.amount = amount;
			this.count = count;
		}
		@Override
		public void run() {
			for (int i = 0; i < count; ++i) {
				account.addAmount(amount);
			}
		}
	}

	@Test
	public void testDeposit() {
		Account account = new Account();
		Thread t1 = new Thread(new Banker(account,  5, 5));
		Thread t2 = new Thread(new Banker(account,  5, 10));
		t1.start();
		t2.start();
		try {
			t1.join();
			t2.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		//System.out.println(account.getBalance());
		assertEquals(account.getBalance(), 75, 0);
	}

	@Test
	public void testBalance() {
		Account account = new Account();
		int amount = Verify.getInt(-100, 100);
		account.addAmount(amount);
		assertTrue(account.getBalance() >= 0);
		assertEquals(amount, account.getBalance(), 0);
	}

}
